import { p as a, r as j, j as c, c as y } from "./Rivet-DdttLb6e.js";
import _, { useState as C } from "react";
import { T as m } from "./TestUtils-Hg0n9mQ7.js";
const x = ({
  children: t,
  className: e,
  controlId: o,
  testMode: n = !1,
  title: s,
  ...l
}) => {
  const r = ["rvt-tabs__panel", e];
  return /* @__PURE__ */ c.jsx(
    "div",
    {
      "aria-labelledby": o,
      className: y(r),
      role: "tabpanel",
      tabIndex: "0",
      ...n && {
        "data-testid": `${m.Tabs.panel}-${o}`
      },
      ...l,
      children: t
    }
  );
};
x.displayName = "TabPanel";
x.propTypes = {
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: a.bool,
  /** The panel's title in the list of tabs*/
  title: a.oneOfType([a.string, a.element]).isRequired
};
const q = j(x), N = (t, e) => `tab_${t}_control_${e}`, u = ({
  children: t,
  className: e,
  id: o,
  label: n,
  initialTab: s,
  onChange: l = () => {
  },
  testMode: r = !1,
  ...b
}) => {
  const I = s && s >= 0 && s < _.Children.count(t), [p] = C(o), [$, P] = C(
    I ? N(p, s) : N(p, 0)
  ), f = t ? _.Children.map(t, (d, T) => {
    const { title: k } = d.props, i = `tab_${p}_control_${T}`, R = (O) => {
      l(O, T, p), P(i);
    }, v = {
      controlId: i,
      key: T
    };
    $ !== i && (v.hidden = !0);
    const E = _.cloneElement(d, v);
    return {
      onClick: R,
      controlId: i,
      label: k,
      panel: E,
      selected: $ === i,
      testMode: r
    };
  }) : [], g = f.map(({ panel: d }) => d), h = ["rvt-tabs", e];
  return /* @__PURE__ */ c.jsxs(
    "div",
    {
      className: y(h),
      ...r && { "data-testid": m.Tabs.container },
      ...b,
      children: [
        /* @__PURE__ */ c.jsx(A, { label: n, tabs: f, testMode: r }),
        g
      ]
    }
  );
};
u.displayName = "Tabs";
u.propTypes = {
  /** A unique identifier for the tab list */
  id: a.string,
  /** An unseen label for the menu to help with accessibility */
  label: a.string.isRequired,
  /** Index of initially opened tab starting at index 0 */
  initialTab: a.number,
  /** Callback function triggered when tabs change, Params: event, index of new tab panel, id of tabs changed */
  onChange: a.func,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: a.bool
};
u.Panel = q;
const A = (t) => {
  const { label: e, tabs: o, testMode: n } = t;
  return /* @__PURE__ */ c.jsx(
    "div",
    {
      "aria-label": e,
      className: "rvt-tabs__tablist",
      role: "tablist",
      ...n && { "data-testid": m.Tabs.controls },
      children: o.map((s) => {
        const { controlId: l } = s;
        return /* @__PURE__ */ c.jsx(M, { ...s }, `tab-${l}`);
      })
    }
  );
}, M = (t) => {
  const { controlId: e, label: o, onClick: n, selected: s, testMode: l } = t, r = (b) => {
    b.preventDefault(), b.stopPropagation(), n();
  };
  return /* @__PURE__ */ c.jsx(
    "button",
    {
      "aria-selected": s,
      className: "rvt-tabs__tab",
      id: e,
      onClick: r,
      role: "tab",
      ...!s && { tabIndex: "-1" },
      ...l && {
        "data-testid": `${m.Tabs.controls}-${e}`
      },
      children: o
    }
  );
}, U = j(u);
export {
  U as T
};
