import { p as o, r as f, j as d, c as u, s as C } from "./Rivet-DdttLb6e.js";
import "react";
const T = "rvt-container", h = (s) => `${T}-${s}`, $ = ({
  className: s,
  children: n,
  component: t = "div",
  id: e = C(),
  size: r = "md",
  ...c
}) => {
  const a = t;
  return /* @__PURE__ */ d.jsx(
    a,
    {
      id: e,
      className: u(h(r), s),
      ...c,
      children: n
    }
  );
};
$.displayName = "Container";
$.propTypes = {
  /** Sets the containing element. Defaults is 'div' */
  component: o.string,
  /** A unique identifier for the container */
  id: o.string,
  /** The size (width) of the container https://github.com/indiana-university/rivet-source/blob/2.0.0-master/src/sass/grid/_base.scss#L30 */
  size: o.oneOf(["sm", "md", "lg", "xl"])
};
const q = f($), x = "rvt-row", S = (s) => s ? `${x}--${s}` : "", g = ({
  className: s,
  children: n,
  component: t = "div",
  id: e = C(),
  spacing: r,
  ...c
}) => {
  const a = t;
  return /* @__PURE__ */ d.jsx(
    a,
    {
      id: e,
      className: u(x, S(r), s),
      ...c,
      children: n
    }
  );
};
g.displayName = "Row";
g.propTypes = {
  /** Sets the containing element. Defaults is 'div' */
  component: o.string,
  /** A unique identifier for the row */
  id: o.string,
  /** Spacing modifier for the Row. Loose for extra spacing between rows, tight for less spacing between rows */
  spacing: o.oneOf(["loose", "tight"])
};
const A = f(g), i = "rvt-cols", O = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12], z = O.map((s) => s + ""), p = [...O, ...z], l = ["sm", "md", "lg", "xl"], B = (s, n, t) => {
  let e = t;
  return e += `-${n}`, s && (e += `-${s}`), e;
}, E = (s, n) => {
  if (!(s || n))
    return i;
  if (typeof s == "string" || typeof s == "number") {
    const t = l.includes(n) ? n : "";
    return m(t, s);
  }
  return n ? m(n, "") : P(s);
}, P = (s) => l.filter((n) => s.hasOwnProperty(n)).map((n) => m(n, s[n])).join(" "), m = (s, n) => {
  const t = l.includes(s) ? `-${s}` : "", r = (p.includes(n) ? `-${n}` : "") + t;
  return i + r;
}, y = ({
  className: s,
  children: n,
  component: t = "div",
  id: e = C(),
  columnWidth: r,
  breakpoint: c,
  shiftBreakpoint: a,
  shiftType: v,
  shiftWidth: N,
  last: j = !1,
  ...w
}) => {
  const R = t;
  return /* @__PURE__ */ d.jsx(
    R,
    {
      id: e,
      className: u(
        `${E(r, c)}`,
        v && B(
          a,
          N,
          `${i}-${v}`
        ),
        j && `${i}--last`,
        s
      ),
      ...w,
      children: n
    }
  );
};
y.displayName = "Col";
y.propTypes = {
  /** A unique identifier for the column */
  id: o.string,
  breakpoint: o.oneOf(l),
  /** Width of the column (1-12) */
  // prettier-ignore
  columnWidth: o.oneOfType([o.oneOf(p), o.object]),
  /** Sets the containing element. The default container element is a 'div' */
  component: o.string,
  /** Place the column at the end of the row. Should only be used on last column in the row */
  last: o.bool,
  /** Indicates the breakpoint at which to pull or push the column. Requires shiftBreakpoint to be set. */
  shiftBreakpoint: o.oneOf(["sm", "md", "lg", "xl"]),
  /** Indicates the number of columns to push or pull the column. Requires shiftType to be set. */
  // prettier-ignore
  shiftWidth: o.oneOf(p),
  /** Can be set to pull or push the column to the left or right, respectively */
  shiftType: o.oneOf(["pull", "push"])
};
const D = f(y);
export {
  q as C,
  A as R,
  D as a
};
