import { p as s, r as y, c as A, j as e, s as b } from "./Rivet-DdttLb6e.js";
import { useState as w } from "react";
import { T as m } from "./TestUtils-Hg0n9mQ7.js";
const n = ({
  title: t,
  onDismiss: r,
  variant: a = "info",
  isOpen: i = !0,
  id: l = b(),
  className: u,
  children: f,
  testMode: o = !1,
  ...g
}) => {
  const d = l, c = d + "-title", h = () => /* @__PURE__ */ e.jsx("div", { className: "rvt-alert__title", id: c, children: t }), v = () => r ? /* @__PURE__ */ e.jsxs(
    "button",
    {
      className: "rvt-alert__dismiss",
      "data-rvt-alert-close": !0,
      onClick: r,
      ...o && { "data-testid": m.Alert.dismiss },
      children: [
        /* @__PURE__ */ e.jsx("span", { className: "rvt-sr-only", children: "Dismiss this alert" }),
        /* @__PURE__ */ e.jsx(
          "svg",
          {
            "aria-hidden": "true",
            xmlns: "http://www.w3.org/2000/svg",
            width: "16",
            height: "16",
            viewBox: "0 0 16 16",
            children: /* @__PURE__ */ e.jsx(
              "path",
              {
                fill: "currentColor",
                d: "M9.41,8l5.29-5.29a1,1,0,0,0-1.41-1.41L8,6.59,2.71,1.29A1,1,0,0,0,1.29,2.71L6.59,8,1.29,13.29a1,1,0,1,0,1.41,1.41L8,9.41l5.29,5.29a1,1,0,0,0,1.41-1.41Z"
              }
            )
          }
        )
      ]
    }
  ) : null, x = A("rvt-alert", `rvt-alert--${a}`, u), j = t ? { "aria-labelledby": c } : {};
  return i ? /* @__PURE__ */ e.jsxs(
    "div",
    {
      id: d,
      className: x,
      role: "alert",
      "data-rvt-alert": a,
      ...o && { "data-testid": m.Alert.container },
      ...j,
      ...g,
      children: [
        h(),
        /* @__PURE__ */ e.jsx("p", { className: "rvt-alert__message", children: f }),
        v()
      ]
    }
  ) : null;
};
n.displayName = "Alert";
n.propTypes = {
  /** A unique identifier for the alert */
  id: s.string,
  /** Determines whether the alert is displayed or hidden */
  isOpen: s.bool,
  /** A function that can be called to have side-effects when the alert dismissal button is selected */
  onDismiss: s.func,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: s.bool,
  /** An extremely brief title for the alert */
  title: s.oneOfType([s.string, s.element]),
  /** The variant type which determines how the alert is styled */
  variant: s.oneOf(["info", "success", "warning", "danger"])
};
const N = y(n), p = ({ onDismiss: t, ...r }) => {
  const [a, i] = w(!0), l = () => {
    i(!1), t && t();
  };
  return /* @__PURE__ */ e.jsx(N, { onDismiss: l, isOpen: a, ...r });
};
p.displayName = "DismissableAlert";
p.propTypes = {
  /** A unique identifier for the alert */
  id: s.string,
  /** A function that can be called to have side-effects when the alert is dismissed */
  onDismiss: s.func,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: s.bool,
  /** An extremely brief title for the alert */
  title: s.oneOfType([s.string, s.element]).isRequired,
  /** The variant type which determines how the alert is styled */
  variant: s.oneOf(["info", "success", "warning", "danger"]).isRequired
};
export {
  N as A,
  p as D
};
