import { p as e, r as P, c as E, j as r, P as O } from "./Rivet-DdttLb6e.js";
import { useState as R, useEffect as b, createRef as m } from "react";
import { h as k, i as I, a as K, b as B, c as z, t as G, d as U } from "./EventUtils-A0HOIKhp.js";
import { B as $ } from "./Button-Clwzx7qN.js";
import "./SegmentedButton-GEKTbkjt.js";
import { T as F } from "./TestUtils-Hg0n9mQ7.js";
import "./plus-EeVSrAS2.js";
const p = ({
  toggleDropdownOnClickInside: t = !1,
  alignRight: o = !1,
  children: a,
  className: h,
  label: l,
  menuClass: w,
  modifier: x,
  size: y,
  ...D
}) => {
  const [n, j] = R(!1);
  b(() => (C(), () => {
    d.deregister();
  }));
  const c = o ? "right" : "left", v = (s) => {
    s && _(s) && (g(s), I(s) && i.current && i.current.focus());
  }, i = m(), u = m(), d = k(v), T = E(
    {
      "rvt-dropdown__menu": !0,
      [`rvt-dropdown__menu--${c}`]: !!c
    },
    w
  ), g = (s) => {
    j(!n), s.stopPropagation && s.stopPropagation();
  }, _ = (s) => {
    if (K(s) || B(s))
      return !1;
    const N = !z(s) && !t;
    return !(G(u.current, s) && (N || U(s)));
  }, C = () => {
    n ? d.register() : d.deregister();
  };
  return /* @__PURE__ */ r.jsxs("div", { className: "rvt-dropdown", ref: u, children: [
    /* @__PURE__ */ r.jsxs(
      $,
      {
        type: "button",
        ...D,
        size: y,
        modifier: x,
        innerRef: i,
        className: h,
        "aria-haspopup": "true",
        "aria-expanded": n,
        onClick: g,
        children: [
          l && /* @__PURE__ */ r.jsx(
            "span",
            {
              className: "rvt-dropdown__toggle-text",
              "data-testid": F.Dropdown.testId,
              children: l
            }
          ),
          /* @__PURE__ */ r.jsx("rvt-icon", { name: "chevron-down" })
        ]
      }
    ),
    n && /* @__PURE__ */ r.jsx("div", { className: T, "aria-hidden": !n, role: "menu", children: a })
  ] });
};
p.displayName = "Dropdown";
p.propTypes = {
  /** Optional flag that determines the alignment of the dropdown menu items relative to the edge of the dropdown button. */
  alignRight: e.bool,
  /**
   * Optional text which appears on the dropdown toggle button. The label
   * should always be provided with a standalone dropdown, however the label
   * can be omitted if the dropdown is part of a SegmentedButton.
   * @see https://rivet.uits.iu.edu/components/navigation/dropdown/
   * @see https://rivet.uits.iu.edu/components/forms/buttons-segmented/#using-segmented-buttons-with-dropdowns
   */
  label: e.node,
  /** Optional CSS classes which will be applied to the dropdown menu */
  menuClass: e.string,
  /** Optional Rivet style: a secondary button. */
  modifier: e.string,
  /** Optional Rivet style: a small button. */
  size: e.string,
  /** Optional flag to toggle the dropdown open state when a click is done within the dropdown contents */
  toggleDropdownOnClickInside: e.bool,
  /**
   * Optional Rivet style: a success/danger/plain button.
   * The 'navigation' variant is intended to support the Header component only.
   */
  variant: e.oneOf(["success", "danger", "plain"])
};
const L = P(p), f = ({ children: t, label: o, ...a }) => /* @__PURE__ */ r.jsxs(r.Fragment, { children: [
  o && /* @__PURE__ */ r.jsx("div", { className: "rvt-dropdown__menu-heading", "aria-hidden": "true", children: o }),
  /* @__PURE__ */ r.jsx("div", { ...a, role: "group", "aria-label": o, children: t })
] });
f.displayName = "DropdownGroup";
f.propTypes = {
  /**
   * Optional header for a related group of menu items.
   */
  label: O.node
};
export {
  L as D,
  f as a
};
