import { p as a, r as u, j as e, c as _, s as h } from "./Rivet-DdttLb6e.js";
import { useState as f } from "react";
import { T as r } from "./TestUtils-Hg0n9mQ7.js";
import "./chevron-down-DnO6t-nE.js";
const x = ({
  className: c,
  children: d,
  current: v = !1,
  onClick: l,
  testMode: t = !1,
  url: s,
  ...n
}) => {
  const o = ["rvt-sidenav__item", c], i = l ? (p) => {
    p.preventDefault(), l(p);
  } : null;
  return /* @__PURE__ */ e.jsxs(
    "li",
    {
      className: _(o),
      ...t && { "data-testid": r.Sidenav.item },
      ...!s && { ...n },
      children: [
        s && /* @__PURE__ */ e.jsx(
          "a",
          {
            className: "rvt-sidenav__link",
            onClick: i,
            href: s,
            ...v && { "aria-current": "page" },
            ...n,
            children: d
          }
        ),
        !s && /* @__PURE__ */ e.jsx(e.Fragment, { children: d })
      ]
    }
  );
};
x.displayName = "SidenavItem";
x.propTypes = {
  /** Indicates item is current page if link with url */
  current: a.bool,
  /** Optional onClick handler for url anchor tag, it will prevent the anchor tag's default behavior */
  onClick: a.func,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: a.bool,
  /** The url for the nav item, makes item a link */
  url: a.string
};
const b = u(x), N = ({
  className: c,
  children: d,
  current: v = !1,
  startOpen: l = !1,
  label: t,
  testMode: s = !1,
  url: n,
  ...o
}) => {
  const [i, p] = f(l), j = ["rvt-sidenav__item", c];
  return /* @__PURE__ */ e.jsxs(
    "li",
    {
      className: _(j),
      ...s && { "data-testid": r.Sidenav.menu },
      ...o,
      children: [
        /* @__PURE__ */ e.jsxs("div", { className: "rvt-sidenav__item-wrapper", children: [
          n && /* @__PURE__ */ e.jsx(
            "a",
            {
              className: "rvt-sidenav__link",
              href: n,
              ...v && { "aria-current": "page" },
              ...s && { "data-testid": r.Sidenav.menuLabel },
              children: t
            }
          ),
          !n && /* @__PURE__ */ e.jsx(
            "span",
            {
              className: "rvt-sidenav__link",
              ...s && { "data-testid": r.Sidenav.menuLabel },
              children: t
            }
          ),
          /* @__PURE__ */ e.jsxs(
            "button",
            {
              "aria-expanded": i,
              "aria-haspopup": i,
              className: "rvt-sidenav__toggle",
              onClick: (S) => {
                S.preventDefault(), S.stopPropagation(), p(!i);
              },
              ...s && { "data-testid": r.Sidenav.menuButton },
              children: [
                /* @__PURE__ */ e.jsxs("span", { className: "rvt-sr-only", children: [
                  i ? "Hide" : "Show",
                  " links nested under ",
                  t
                ] }),
                /* @__PURE__ */ e.jsx("rvt-icon", { name: "chevron-down" })
              ]
            }
          )
        ] }),
        /* @__PURE__ */ e.jsx(
          "ul",
          {
            className: "rvt-sidenav__list",
            hidden: !i,
            ...s && { "data-testid": r.Sidenav.menuContent },
            children: d
          }
        )
      ]
    }
  );
};
N.displayName = "SidenavMenu";
N.propTypes = {
  /** Defaults the menu to open when first created */
  startOpen: a.bool,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: a.bool,
  /** The url for the menu label, makes the label a link */
  url: a.string
};
const g = u(N), m = ({
  className: c,
  children: d,
  id: v = h(),
  label: l,
  testMode: t = !1,
  ...s
}) => {
  const n = ["rvt-sidenav", c], o = `${v}-sidenav-label`;
  return /* @__PURE__ */ e.jsxs(
    "nav",
    {
      "aria-labelledby": o,
      className: _(n),
      ...t && { "data-testid": r.Sidenav.container },
      ...s,
      children: [
        /* @__PURE__ */ e.jsx("span", { className: "rvt-sidenav__label", id: o, children: l }),
        /* @__PURE__ */ e.jsx("ul", { className: "rvt-sidenav__list", children: d })
      ]
    }
  );
};
m.displayName = "Sidenav";
m.propTypes = {
  /** A unique identifier for the component */
  id: a.string,
  /** The label for the navigation */
  label: a.node.isRequired,
  /** [Developer] Adds data-testId attributes for component testing */
  testMode: a.bool
};
m.Item = b;
m.Menu = g;
const C = u(m);
export {
  C as S
};
