import { p as r, r as i, c as d, j as s, a as k, s as b } from "./Rivet-DdttLb6e.js";
import * as f from "react";
import { I as $ } from "./RivetIcons-bZQU0zm1.js";
const x = ({
  children: e,
  className: t,
  copyrightYear: o,
  openInNewWindow: a = !1,
  privacyUrl: m,
  size: l = "sm",
  variant: n,
  ...p
}) => {
  const c = d(
    "rvt-footer-base",
    n ? `rvt-footer-base--${n}` : "",
    t
  ), u = o || (/* @__PURE__ */ new Date()).getFullYear();
  return /* @__PURE__ */ s.jsx("footer", { className: c, ...p, children: /* @__PURE__ */ s.jsx("div", { className: k(l, F, "rvt-container"), children: /* @__PURE__ */ s.jsxs("div", { className: "rvt-footer-base__inner", children: [
    /* @__PURE__ */ s.jsx("div", { className: "rvt-footer-base__logo", children: /* @__PURE__ */ s.jsx($, { height: "24", name: "logo", viewBox: "0 0 24 24", width: "24" }) }),
    /* @__PURE__ */ s.jsxs(
      "ul",
      {
        className: `rvt-footer-base__list ${l === "full" ? "rvt-m-lr-sm" : ""}`,
        children: [
          /* @__PURE__ */ s.jsx(
            N,
            {
              openInNewWindow: a,
              url: "https://accessibility.iu.edu/assistance/",
              children: "Accessibility"
            }
          ),
          /* @__PURE__ */ s.jsx(N, { openInNewWindow: a, url: m, children: "Privacy Notice" }),
          /* @__PURE__ */ s.jsxs("li", { className: "rvt-footer-base__item", children: [
            /* @__PURE__ */ s.jsx(
              "a",
              {
                className: "rvt-footer-base__link",
                href: "https://www.iu.edu/copyright/index.html",
                ...a && { target: "_blank" },
                children: "Copyright"
              }
            ),
            " ",
            "© ",
            u,
            " The Trustees of",
            " ",
            /* @__PURE__ */ s.jsx(
              "a",
              {
                className: "rvt-footer-base__link",
                href: "https://www.iu.edu",
                ...a && { target: "_blank" },
                children: "Indiana University"
              }
            )
          ] })
        ]
      }
    )
  ] }) }) });
}, N = ({ children: e, openInNewWindow: t, url: o }) => o ? /* @__PURE__ */ s.jsx("li", { className: "rvt-footer-base__item", children: /* @__PURE__ */ s.jsx(
  "a",
  {
    className: "rvt-footer-base__link",
    href: o,
    ...t && { target: "_blank" },
    children: e
  }
) }) : null, F = ["sm", "md", "lg", "xl"];
x.displayName = "BaseFooter";
x.propTypes = {
  /** The year of the page copyright */
  copyrightYear: r.string,
  /** The url for privacy link, if no provided url link will not display*/
  privacyUrl: r.string,
  /** The container size for content */
  size: r.oneOf([...F, "full"]),
  /** The variant type which determines how the footer is styled */
  variant: r.oneOf(["light"])
};
const T = i(x), h = ({
  children: e,
  className: t,
  containerClass: o,
  id: a = b(),
  label: m = "Additional resources",
  size: l = "sm",
  ...n
}) => {
  const p = d("rvt-footer-resources", t), c = d(`rvt-container-${l}`, o), u = `${a}-header`;
  return /* @__PURE__ */ s.jsxs(
    "div",
    {
      "aria-labelledby": u,
      className: p,
      role: "complementary",
      ...n,
      children: [
        /* @__PURE__ */ s.jsx("h2", { className: "rvt-sr-only", id: u, children: m }),
        /* @__PURE__ */ s.jsx("div", { className: c, children: e })
      ]
    }
  );
};
h.displayName = "ResourceFooter";
h.propTypes = {
  /** Additional css classes for the content */
  containerClas: r.string,
  /** A unique identifier for the resource footer */
  id: r.string,
  /** The label for the resource footer */
  label: r.node,
  /** The grid container size for content */
  size: r.oneOf(["sm", "md", "lg", "xl"])
};
const I = i(h), v = ({ children: e, label: t, ...o }) => /* @__PURE__ */ s.jsxs("div", { ...o, children: [
  /* @__PURE__ */ s.jsx("h3", { className: "rvt-footer-resources__heading", children: t }),
  /* @__PURE__ */ s.jsx("ul", { className: "rvt-footer-resources__list", children: R(e) })
] }), R = (e) => e ? f.Children.map(e, S) : [], S = (e) => {
  if (typeof e == "string" || typeof e == "number" || e.type !== "li")
    return /* @__PURE__ */ s.jsx("li", { className: "rvt-footer-resources__list-item", children: e });
  const { className: t = "", ...o } = e.props;
  if (!t.includes("rvt-footer-resources__list-item")) {
    const a = {
      className: d("rvt-footer-resources__list-item", t),
      ...o
    };
    return f.cloneElement(e, a);
  }
  return e;
};
v.displayName = "ResourceFooterLinkBlock";
v.propTypes = {
  /** The label for the resource block*/
  label: r.string
};
const M = i(v), y = ({ children: e, label: t, ...o }) => /* @__PURE__ */ s.jsxs("div", { ...o, children: [
  /* @__PURE__ */ s.jsx("h3", { className: "rvt-footer-resources__heading", children: t }),
  /* @__PURE__ */ s.jsx("div", { className: "rvt-footer-resources__text-block", children: e })
] });
y.displayName = "ResourceFooterTextBlock";
y.propTypes = {
  /** The label for the resource block*/
  label: r.string
};
const w = i(y), j = ({
  children: e,
  className: t,
  containerClass: o,
  id: a = b(),
  label: m = "Social media",
  size: l = "sm",
  ...n
}) => {
  d("rvt-footer-social", t);
  const p = d(`rvt-container-${l}`, o), c = `${a}-header`;
  return /* @__PURE__ */ s.jsx(
    "div",
    {
      "aria-labelledby": c,
      className: "rvt-footer-social",
      role: "complementary",
      ...n,
      children: /* @__PURE__ */ s.jsxs("div", { className: p, children: [
        /* @__PURE__ */ s.jsx("h2", { className: "rvt-sr-only", id: c, children: m }),
        /* @__PURE__ */ s.jsx("ul", { className: "rvt-footer-social__list", children: B(e) })
      ] })
    }
  );
}, B = (e) => e ? f.Children.map(e, L) : [], L = (e) => typeof e.type == "function" ? e : typeof e == "string" || typeof e == "number" || e.type !== "li" ? /* @__PURE__ */ s.jsx("li", { children: e }) : e;
j.displayName = "SocialMediaFooter";
j.propTypes = {
  /** Additional css classes for the content */
  containerClas: r.string,
  /** A unique identifier for the resource footer */
  id: r.string,
  /** The label for the social media footer (screen reader only) */
  label: r.string,
  /** The grid container size for content */
  size: r.oneOf(["sm", "md", "lg", "xl"])
};
const z = i(j), _ = ({ children: e, label: t, url: o, ...a }) => o ? /* @__PURE__ */ s.jsx("li", { ...a, children: /* @__PURE__ */ s.jsxs("a", { href: o, children: [
  /* @__PURE__ */ s.jsx("span", { className: "rvt-sr-only", children: t }),
  e
] }) }) : null;
_.displayName = "SocialMediaFooterLink";
_.propTypes = {
  /** The label for the social media link (screen reader only)" */
  label: r.string,
  /** The url for social media link, if no provided url link will not display*/
  url: r.string
};
const E = i(_), g = ({ children: e, ...t }) => /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
  e,
  /* @__PURE__ */ s.jsx(T, { ...t })
] });
g.displayName = "StandardFooter";
g.propTypes = {
  /** Additional content to be placed above the footer */
  children: r.oneOfType([
    r.arrayOf(r.node),
    r.node
  ]),
  /** The url for privay link, if no provided url link will not display */
  privacyUrl: r.string,
  /** The container size for content */
  size: r.oneOf(["sm", "md", "lg", "xl", "full"]),
  /** The variant type which determines how the footer is styled */
  variant: r.oneOf(["light"])
};
const U = i(g);
export {
  T as B,
  I as R,
  z as S,
  M as a,
  w as b,
  E as c,
  U as d
};
