const e = {
  Accordion: {
    container: "accordion-container",
    header: "accordion-header",
    panel: "accordion-panel"
  },
  Alert: {
    container: "Alert-container",
    dismiss: "Alert-dismiss"
  },
  CallToAction: {
    link: "cta-link"
  },
  ButtonGroup: { testId: "buttonGroup_testId" },
  SegmentedButton: { testId: "segmentedButton_testId" },
  RivetIcons: { testId: "rivetIcon_testId" },
  Dialog: {
    dialogHeaderTestId: "dialogHeader__testId",
    underlayDivTestId: "underlayDiv__testId",
    dialogBodyTestId: "dialogBody__testId",
    dialogControlsTestId: "dialogControlsTestId__testId"
  },
  Dropdown: { testId: "testId" },
  Header: {
    skipLinkTestId: "skip-link__testid",
    anchorTestId: "header-anchor__testid",
    searchWrapperTestId: "search-wrapper__testid",
    navButtonToggleTestId: "nav-button-toggle__testid",
    navButtonToggleIcon: "nav-button-toggle__icon",
    menuButtonToggleTestId: "menu-button-toggle__testid",
    menuAnchorTestId: "menu-anchor-toggle__testid",
    menuContainerTestId: "menu-container__testid",
    menuItemsContainerTestId: "menu-items-container__testid",
    navListItemTestId: "nav-list-item__testid",
    headerNavTestId: "header-nav__testid",
    searchToggleButtonTestId: "search-toggle-button__testid",
    searchButtonTestId: "search-button__testid",
    searchFormTestId: "search-form__testid",
    searchInputTestId: "search-input__testid",
    secondaryNavTestId: "secondary-nav__testid",
    secondaryNavContainerTestId: "nav-secondary-container__testid",
    secondaryNavToggleTestId: "secondary-nav-toggle__testid",
    avatarOuterDivTestId: "avatar-outer-div__testid",
    avatarShortNameTestId: "avatar-short-name__testid",
    avatarUsernameTestId: "avatar-username__testid",
    headerWidthDivTestId: "header-width__testid",
    headerMenuItemContainer: "header-menuitem__container",
    headerMenuItemAnchor: "header-menuitem__anchor"
  },
  Hero: {
    container: "hero-container",
    innerContainer: "hero-inner",
    eyebrow: "hero-eyebrow",
    title: "hero-title",
    content: "hero-content",
    actions: "hero-actions",
    media: "hero-media",
    mediaCaption: "hero-mediaCaption"
  },
  Disclosure: { testId: "disclosure__testId" },
  Billboard: {
    container: "billboard-container",
    content: "billboard-content",
    image: "billboard-image",
    title: "billboard-title"
  },
  CalendarTile: {
    container: "calendartile-container",
    day: "calendartile-day",
    month: "calendartile-month",
    year: "calendartile-year"
  },
  Card: {
    container: "card-container",
    content: "card-content",
    eyebrow: "card-eyebrow",
    image: "card-image",
    meta: "card-meta",
    title: "card-title"
  },
  Quote: {
    container: "quote-container",
    content: "quote-content",
    avatar: "quote-avatar",
    citation: "quote-citation"
  },
  Stat: {
    container: "stat-container",
    description: "stat-description",
    group: "stat-group",
    image: "stat-image",
    number: "stat-number"
  },
  StepIndicator: {
    container: "stepIndicator-container",
    step: "stepIndicator-step"
  },
  Timeline: { testId: "timeline__testId" },
  SeriesNav: {
    container: "seriesNav-container",
    controlLabel: "seriesNav-label",
    controlText: "seriesNav-text",
    controlIcon: "seriesNav-icon",
    previous: "seriesNav-previous",
    next: "seriesNav-next"
  },
  Sidenav: {
    container: "sidenav-container",
    item: "sidenav-item",
    menu: "sidenav-menu",
    menuButton: "sidenav-menu-button",
    menuContent: "sidenav-menu-content",
    menuLabel: "sidenav-menu-label"
  },
  Subnav: {
    container: "subnav-container",
    itemContainer: "subnav-item",
    itemLink: "subnav-item-link"
  },
  Switch: {
    container: "switch-container"
  },
  Tabs: {
    container: "tabs-container",
    controls: "tabs-controls",
    panel: "tabs-panel"
  },
  LinkHub: {
    container: "linkhub-container",
    itemContainer: "linkhub-description",
    itemLink: "linkhub-group"
  }
};
export {
  e as T
};
